function ui_init(player)
	local refresh_needed = false
	if player.gui.left["extra-ui"] == nil then
		player.gui.left.add({type="frame", name="extra-ui", direction="horizontal", caption="Details:"})
		refresh_needed = true
	end
	if player.gui.left["uihidden"] == nil then
		player.gui.left.add({type="button",name="uihidden", style=LuaStyle, caption="-"})		--unhidden
		refresh_needed = true
	end
	if refresh_needed == true then
		destroy_ui(player.gui.left["extra-ui"])
		create_ui(player.gui.left["extra-ui"])
	end
end

function create_ui(frame)
	frame.add({type="flow",name="Labels",caption="",direction="vertical"})
	frame.add({type="flow",name="Values",caption="",direction="vertical"})
	frame.Labels.add({type="label", name="Glabel", caption="GameTime"})
	frame.Labels.add({type="label", name="Elabel", caption="Evo %"})
	frame.Labels.add({type="label", name="Tlabel", caption="Time"})
	frame.Labels.add({type="label", name="Olabel", caption="Oxygen"})
	frame.Labels.add({type="label", name="Wlabel", caption="Water"})
	frame.Labels.add({type="label", name="Flabel", caption="Food"})	
	frame.Values.add({type="label", name="Gvalue", style=LuaStyle, caption=tostring(game_time_convert())})
	frame.Values.add({type="label", name="Evalue", style=LuaStyle, caption=tostring(evo_factor())})
	frame.Values.add({type="label", name="Tvalue", style=LuaStyle, caption=tostring(time_convert())})
	frame.Values.add({type="label", name="Ovalue", style=LuaStyle, caption=tostring(Config.MaxOxygen)})	
	frame.Values.add({type="label", name="Wvalue", style=LuaStyle, caption=tostring(Config.MaxWater)})	
	frame.Values.add({type="label", name="Fvalue", style=LuaStyle, caption=tostring(Config.MaxFood)})
end

function destroy_ui(frame)
	if frame.Labels ~= nil then frame.Labels.destroy() end
	if frame.Values ~= nil then frame.Values.destroy() end
end

function update_gui_perform(player,valueo,valuew,valuef)
	ui_init(player)
	if player.gui.left["uihidden"].caption == "-" then
		if (player.gui.left["extra-ui"]["Values"] == nil) then create_ui(player.gui.left["extra-ui"]) end
		
		player.gui.left["extra-ui"]["Values"]["Gvalue"].caption = tostring(game_time_convert())
		player.gui.left["extra-ui"]["Values"]["Tvalue"].caption = tostring(time_convert())
		player.gui.left["extra-ui"]["Values"]["Evalue"].caption = tostring(evo_factor())
		
		local labe = player.gui.left["extra-ui"]["Labels"]["Olabel"]
		local ival = player.get_inventory(defines.inventory.player_main).get_item_count("oxygen-bottle")
		label_coloring(labe,ival,Config.OxygenInvWarning)
		local cap = player.gui.left["extra-ui"]["Values"]["Ovalue"]
		cap.caption = tostring(valueo)
		level_coloring(cap,valueo)
		
		labe = player.gui.left["extra-ui"]["Labels"]["Wlabel"]
		ival = player.get_inventory(defines.inventory.player_main).get_item_count("water-bottle")
		label_coloring(labe,ival,Config.WaterInvWarning)
		cap = player.gui.left["extra-ui"]["Values"]["Wvalue"]
		cap.caption = tostring(valuew)
		level_coloring(cap,valuew)
		
		labe = player.gui.left["extra-ui"]["Labels"]["Flabel"]
		ival = player.get_inventory(defines.inventory.player_main).get_item_count("potato")
		label_coloring(labe,ival,Config.FoodInvWarning)
		cap = player.gui.left["extra-ui"]["Values"]["Fvalue"]
		cap.caption = tostring(valuef)
		level_coloring(cap,valuef)
	else
		if (player.gui.left["extra-ui"]["Values"] ~= nil) then
			destroy_ui(player.gui.left["extra-ui"])
		end
	end
end

function label_coloring(labe,ival,warning_level)
	if (ival <= 0) then labe.style.font_color = {r=1} 
	elseif (ival < warning_level) then labe.style.font_color = {r=1,g=1} 
	else labe.style.font_color = {r=1,g=1,b=1} end
end

function level_coloring(cap,tval)
	if (tval < 20) then cap.style.font_color = {r=1} 
	elseif (tval < 50) then cap.style.font_color = {r=1,g=1} 
	else cap.style.font_color = {r=1,g=1,b=1} end
end

function game_time_convert()
	local temptime = game.tick / 60					-- Convert "tick" to second
	local tempsec = math.floor(temptime % 60)
	local tempmin = math.floor((temptime/60)%60)
	local temphour = math.floor(temptime/3600)
	return string.format("%d",temphour % 24) .. ":" .. string.format("%02d",tempmin % 60) .. ":" .. string.format("%02d",tempsec)
end

function time_convert()
	local temptime = (game.daytime) * 1440
	local tempmin = math.floor(temptime % 60)
	local temphour = math.floor((temptime - tempmin)/60) + 12
	return string.format("%02d",temphour % 24) .. ":" .. string.format("%02d",tempmin)
end

function evo_factor()
	return string.format("%.6f",game.evolution_factor)
end